unit uRotation2axes;

interface

uses
  System.Classes, System.Types, System.UITypes, System.SysUtils, FMX.Types,
  FMX.Types3D, FMX.Controls3D ;

type
  TRotation2axes = class
  public
    aCtrl3D: TControl3D ;
    aList : TStringList ;
    PositionSouris, RotationObjet: TPointf;
    constructor Create (aCtrl3D1: TControl3D; aList1 : TStrings);
    procedure MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Single);
    procedure MouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Single);
    procedure DessineObjet ;
    procedure Reset ;
    function LatitudeLongitude: string;
  end;

implementation

{ TRotation2axes }

constructor TRotation2axes.Create(aCtrl3D1: TControl3D; aList1 : TStrings);
begin
  aCtrl3D := aCtrl3D1 ;
  RotationObjet := PointF (0,0) ;
  aList := TStringList (Alist1) ;
end;

procedure TRotation2axes.MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  PositionSouris := PointF(X,Y) ; // Pour MouseMove1
end;

procedure TRotation2axes.MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Single);
var
  Delta: TPointf;
begin
  Delta := PointF(PositionSouris.X - X, PositionSouris.Y - Y);
  PositionSouris := PointF(X, Y);
  if abs(Delta.X) > abs(Delta.Y) then
    Delta.Y := 0
  else
    Delta.X := 0;
  if ssLeft in Shift then
  begin
    RotationObjet.Y := RotationObjet.Y + (Delta.X / 3);
    RotationObjet.X := RotationObjet.X - (Delta.Y / 3);
  end;
  if RotationObjet.X < -90 then
    RotationObjet.X := -90;
  if RotationObjet.X > 90 then
    RotationObjet.X := 90;
  DessineObjet ;
end;

procedure TRotation2axes.Reset;
begin
  RotationObjet := PointF (0,0) ;
  DessineObjet ;
end;

procedure TRotation2axes.DessineObjet;
begin
aCtrl3D.BeginUpdate;
aCtrl3D.ResetRotationAngle;
aCtrl3D.RotationAngle.X := RotationObjet.X - 20;
aCtrl3D.RotationAngle.Y := RotationObjet.Y - 90;
aCtrl3D.EndUpdate;
aCtrl3D.Repaint;
  if aList <> nil then
    aList.Text := LatitudeLongitude ;
end;

function TRotation2axes.LatitudeLongitude: string;
var
  sl1: TStringList;
  stNordSud, stEstOuest: string;
begin
  sl1 := TStringList.Create;
  if RotationObjet.X < 0 then
    stNordSud := 'Sud'
  else
    stNordSud := 'Nord';
  sl1.Add(Format('Latitude : %.0f ', [abs(RotationObjet.X)]) + stNordSud);
  if RotationObjet.Y < 0 then
    stEstOuest := 'Ouest'
  else
    stEstOuest := 'Est';
  sl1.Add(Format('Longitude : %.0f ', [abs(RotationObjet.Y)]) + stEstOuest);
  result := sl1.Text;
  sl1.Free;
end;



initialization

end.
